library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity ALUCONTROL is
    port (
        ALUop: in std_logic_vector(1 downto 0);
        codfunc: in std_logic_vector(5 downto 0);
        op: out std_logic_vector(2 downto 0)
    );

end ALUCONTROL;

architecture BEHAVIOR of ALUCONTROL is
begin

process(ALUop,codfunc)

begin

case ALUop is
 -- LW o SW o addi 
 when "00" => op <= "010";
 -- Branch o subi
 when "01" => op <= "110";
 -- Tipo R
 when "10" => 
     
     case conv_integer(codfunc) is
      when 0 => op <="100";  -- sll
      when 2 => op <= "101"; -- srl
      when 32 => op <="010"; -- add
      when 34 => op <="110"; -- sub
      when 36 => op <="000"; -- and
      when 37 => op <="001"; -- or
      when 38 => op <="011"; -- xor
      when 42 => op <="111"; -- slt
      when others => op <="000";     
     end case;
 when others => op <="000";    
end case;      
end process;


end BEHAVIOR;

