library ieee;
use ieee.std_logic_1164.all;
use work.dati.all;

entity MUX4V32 is
    port (
         r: in w32;
         c: in w32;
         i: in w32;
         s: in w32;
         sel : in std_logic_vector(1 downto 0);
         q: out w32
         );
end MUX4V32;

architecture BEHAVIOR of MUX4V32 is

begin
 process(r,c,i,s,sel)
  variable isel : integer;
 begin
  
  case sel is
   when "00" => q<= r after 1 ns;
   when "01" => q<= c after 1 ns;
   when "10" => q<= i after 1 ns;
   when "11" => q<= s after 1 ns;
   when others => null;
  end case;
 end process;

end BEHAVIOR;


